import 'package:flutter/cupertino.dart';

abstract class BaseShareBean {
  // ignore: non_constant_identifier_names
  static const String PLATFORM_QQ = "qq";
  static const String PLATFORM_QZONE = "qzone";
  static const String PLATFORM_WX = "wechat";
  static const String PLATFORM_WX_pyq = "wechat";
  static const String PLATFORM_WB = "WB";


  //默认分享，包括图文与链接
  static const String SHARETYPE_DEFAULT = "default";
  static const String SHARETYPE_TEXT = "text";
  static const String SHARETYPE_FILE = "file";
  static const String SHARETYPE_PIC = "pic";
  static const String SHARETYPE_VIDEO = "vedio";
  static const String SHARETYPE_MINIPROGRAMME = "miniprogramme";

  String platform;
  String title;
  String targetUrl;
  String description;
  String text;
  String shareType;
  String videoUri;
  String bitmapUri;
  String fileUri;
  String miniAppPath;

  BaseShareBean(
      {@required this.platform,
        this.shareType,
        this.title = "",
        this.targetUrl = "",
        this.description = "",
        this.text = "",
        this.videoUri = "",
        this.bitmapUri = "",
        this.fileUri = "",
        this.miniAppPath = ""});
}

class WebShareBean extends BaseShareBean {
  WebShareBean(
      {@required String platform,
        @required String targetUrl,
        String title = "",
        String description = "",
        String bitmapUri = ""})
      : super(
      platform: platform,
      targetUrl: targetUrl,
      shareType: BaseShareBean.SHARETYPE_DEFAULT,
      title: title,
      bitmapUri: bitmapUri,
      description: description);
}

class TextShareBean extends BaseShareBean {
  TextShareBean({@required String platform, @required String text})
      : super(
      platform: platform,
      targetUrl: text,
      shareType: BaseShareBean.SHARETYPE_TEXT);
}

class FileShareBean extends BaseShareBean {
  FileShareBean({@required String platform, @required String file})
      : super(
      platform: platform,
      fileUri: file,
      shareType: BaseShareBean.SHARETYPE_FILE);
}

class PicShareBean extends BaseShareBean {
  PicShareBean(
      {@required String platform,
        @required String bitmapUri,
        String title,
        String description})
      : super(
      platform: platform,
      bitmapUri: bitmapUri,
      title: title,
      description: description,
      shareType: BaseShareBean.SHARETYPE_PIC);
}

class VideoShareBean extends BaseShareBean {
  VideoShareBean({
    @required String platform,
    @required String videoUri,
    String title,
    String description,
  }) : super(platform: platform, videoUri: videoUri, description: description);
}

class MiniProgramShareBean extends BaseShareBean {
  MiniProgramShareBean(
      {@required String platform,
        @required String miniAppPath,
        String bitmapUri})
      : super(
      platform: platform, miniAppPath: miniAppPath, bitmapUri: bitmapUri);
}
